/********************************************************************
*																	*
*      				 Auto Generated File                            *
*                     												*		
*********************************************************************/

#ifndef __Estimator_H
#define __Estimator_H

/** include files **/
#include "atomic.h"  // class Atomic

/** forward declarations **/
//TODO: add distribution class declaration here if needed
// Ej: class Distribution ;

/** declarations **/
class Estimator: public Atomic
{
public:
	Estimator( const string &name = "Estimator" ) ;	 // Default constructor
	~Estimator();					// Destructor
	virtual string className() const
		{return "Estimator";}

protected:
	Model &initFunction();	
	Model &externalFunction( const ExternalMessage & );
	Model &internalFunction( const InternalMessage & );
	Model &outputFunction( const InternalMessage & );

private:
	const Port &Projectin;
	const Port &Projectsize;
	Port &reqtime;
	Port &designtime;
	Port &imptime;
	int reqtimeout;
	int designtimeout;
	int imptimeout;
	int projSize;
	int ProjIn;
	Time preparationTime;

	// [(!) TODO: declare ports, distributions and other private varibles here]
	/***********      Example declarations   **********************************/
	// const Port &in;	// this is an input port named 'in'
	// Port &out ;   	// this is an output port named 'out'
	// Distribution *dist ;
	// Distribution &distribution()	{ return *dist; }
	/**************************************************************************/

	// [(!) declare common variables]
	// Lifetime programmed since the last state transition to the next planned internal transition.
	Time sigma;
	
	// Time elapsed since the last state transition until now
	Time elapsed;
	
	// Time remaining to complete the last programmed Lifetime
	Time timeLeft;	
};	// class Estimator


#endif   //__Estimator_H 
